/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ij.gui;

import java.awt.Cursor;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Point;
import java.awt.Toolkit;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeSupport;

import java.net.URL;

import java.io.File;

import javax.swing.JOptionPane;
import ij2x.util.ResourceString;
import javax.swing.ImageIcon;
import ij2x.util.AWTImages;
import java.util.MissingResourceException;
import java.util.Locale;
import java.util.ResourceBundle;
import java.util.StringTokenizer;
import java.util.Vector;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2012</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class CustomCursor{

  protected static PropertyChangeSupport pcs;
  protected static ImageCanvas grCanvas;
  protected static Cursor cursor, oldCursor;
  protected URL imageUrl;
  protected static Toolkit tk;
  protected static Image cursorImage;
  protected static Dimension bestSize;
  protected static Cursor[] cursors;
  protected static URL[] curURL;
  protected Point[] curCoordin;
  protected static Image[] cursorImages;
  public static int DRAW=0, FILL=1, SHEARE=2, SCALE=3, ROTATE=4, MOVE=5, HAND=6, TEXT=7;
  protected static String[] custom_cursor = {"DRAW_CCURSOR", "FILL_CCURSOR", "SHEARE_CCURSOR", "SCALE_CCURSOR", "ROTATE_CCURSOR", "MOVE_CCURSOR", "HAND_CCURSOR", "TEXT_CCURSOR"};
  private static ResourceBundle resources;

  static {
      try {
          resources = ResourceBundle.getBundle("ij.gui.resources.CustomCursor",
                                               Locale.getDefault());
      } catch (MissingResourceException mre) {
          System.err.println("resources/CustomCursor.properties not found");
          System.exit(1);
      }
  }

  public CustomCursor(ImageCanvas grCanvas) {
    this.grCanvas=grCanvas;
    pcs = new PropertyChangeSupport(this);
    this.addPropertyChangeListener(new PropertyChangeListener(){
    public void propertyChange(PropertyChangeEvent e){
    cursorChanged_propertyChange(e);
    }
    });
  }
  public Cursor getCustomCursor(){
    return cursor;
  }
  public synchronized static void setCustomCursor(int customcursor, Point focus){
    AWTImages.setImageDir("cursorDir");
    final int colorMax = 65536;
    tk = Toolkit.getDefaultToolkit();
    bestSize = tk.getBestCursorSize(32,32);
    int maxColors = tk.getMaximumCursorColors();

      String[] iconAllName = tokenize(getResourceString("customcursor"));
       for (int i = 0; i < iconAllName.length; i++) {
           //System.out.println("imgName="+iconAllName[i]);
       }
      String imgName=""; 
      Image[] icons = new Image[iconAllName.length];
     try {
         for (int i = 0; i < iconAllName.length; i++) {
             
             imgName=tokenize(getResourceString(iconAllName[i]))[0];
             //if(imgName == null) continue;
                 icons[i] = ((ImageIcon) AWTImages.createIcon(
                         grCanvas, imgName)).getImage();

         }
     }
     catch (Exception ex) {
         ex.printStackTrace();
     }
    if(maxColors != 0 || maxColors <= colorMax){
      if(customcursor < 0 || customcursor > 8) {
        cursor=new Cursor(Cursor.DEFAULT_CURSOR);
      }else{
        cursor = tk.createCustomCursor(icons[customcursor],
                                       focus,
                                       custom_cursor[customcursor]);
      }
     } 
  }
     /**
      * Take the given string and chop it up into a series
      * of strings on whitespace boundaries.  This is useful
      * for trying to get an array of strings out of the
      * resource file.
      */
      protected static String[] tokenize(String input) {
         Vector<String> v = new Vector<String>();
         StringTokenizer t = new StringTokenizer(input);
         String cmd[];

         while (t.hasMoreTokens())
             v.addElement(t.nextToken());
         cmd = new String[v.size()];
         for (int i = 0; i < cmd.length; i++)
             cmd[i] = v.elementAt(i);

         return cmd;
     }
     protected static String getResourceString(String nm) {
        String str;
        try {
            str = resources.getString(nm);
        } catch (MissingResourceException mre) {
            str = null;
        }
        return str;
    }

      protected URL getResource(String key) {
         String name = getResourceString(key);
         if (name != null) {
             URL url = this.getClass().getResource(name);
             return url;
         }
         return null;
     }


  public synchronized void setCustomCursor(Cursor cursor){
      //System.out.println("cursorName="+cursor.getName());
    this.cursor=cursor;
      pcs.firePropertyChange("cursorChanged", oldCursor, cursor);
      oldCursor=cursor;

  }
  void cursorChanged_propertyChange(PropertyChangeEvent e){
    if(e.getPropertyName().equals("cursorChanged")){
      ((ImageCanvas)grCanvas).setCursor(cursor);
    //System.out.println("cursorName="+cursor.getName());
    }
  }

  public void addPropertyChangeListener(PropertyChangeListener p){
     pcs.addPropertyChangeListener(p);
  }

   public void removePropertyChangeListener(PropertyChangeListener p){
      pcs.removePropertyChangeListener(p);
  }

}
