
package ij2x.plugin;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Color;
import java.awt.Dimension;

import java.net.URL;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.Icon;
import javax.swing.border.BevelBorder;
import javax.swing.BorderFactory;
import javax.swing.border.Border;

import ij.IJ;
import ij.ImageJ;
import ij.ImagePlus;
import ij.Prefs;
import ij.WindowManager;
import ij.util.Tools;
import ij.plugin.PlugIn;
import ij2x.plugin.imageborder.ImageBorderPanel;


/**
 * <p>Title: </p>
 *
 * <p>Description: </p>
 *
 * <p>Copyright: Copyright (c) 2012</p>
 *
 * <p>Company: </p>
 *
 * @author not attributable
 * @version 1.0
 */
public class ToolbarBoxControl extends JPanel implements PlugIn, ActionListener, MouseListener, MouseMotionListener {

    protected ImagePlus imp;
    protected ImageJ ij;
    public JButton infoButton, draggedButton, closeButton, undecoratedButton;
    protected JButton brightnesContButton, winLevelButton, resizeCanButton, colorBalButton, thresholdButton;
    private JButton action;
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Border lightGrayBorder = BorderFactory.createBevelBorder(bb.RAISED, Color.lightGray, Color.lightGray);
    private int actionCount = 0;
    private static int current;
    private long mouseDownTime;
    public static final int DOUBLE_CLICK_THRESHOLD = 150;
    public JPanel controlBarPanel=new JPanel();
    public JPanel panel=new JPanel();
    private GridBagLayout gblayout = new GridBagLayout();

    public ToolbarBoxControl() {
    }
    public void run(String arg){
        ij = IJ.getInstance();
        controlBarPanel=createControlBar();
    }

    public JPanel createControlBar(){

        java.awt.FlowLayout flayout = new java.awt.FlowLayout(java.awt.FlowLayout.LEFT);
        flayout.setHgap(0);
        flayout.setVgap(0);
        panel.setLayout(flayout);
        panel.setBorder(lightGrayBorder);
        closeButton = createButton(closeButton, "Decorated Button");
        closeButton.setIcon(createIcon("newplayer/player_a_09"));
        closeButton.setPressedIcon(createIcon("newplayer/player_a_09_press"));
        closeButton.setRolloverIcon(createIcon("newplayer/player_a_09_rolover"));
        undecoratedButton = createButton(undecoratedButton, "Undecorated Button");
        undecoratedButton.setIcon(createIcon("newplayer/player_a_10"));
        undecoratedButton.setPressedIcon(createIcon("newplayer/player_a_10_press"));
        undecoratedButton.setRolloverIcon(createIcon("newplayer/player_a_10_rolover"));

        panel.add(closeButton);

        panel.add(undecoratedButton);
        return panel;
     }
     private JButton createButton(JButton action, String tooltip){
         action = new JButton();
         action.setToolTipText(tooltip);
         action.addActionListener(this);
         action.addMouseListener(this);
         action.addMouseMotionListener(this);
         setBorderlessButton(action);
     return action;
     }

     private Icon createIcon(String key){
         Icon icon = null;
         String dir = Prefs.getString("icondir");
         String fileName=key+".gif";
         String path = dir+fileName;
         URL url = getClass().getResource(path);
         if(url != null)
         icon = new ImageIcon(url);
     return icon;
     }

     void setButtonDim(JButton action, Dimension maxDim, Dimension preDim, Dimension minDim){
       action.setMaximumSize(maxDim);
       action.setPreferredSize(preDim);
       action.setMinimumSize(minDim);
   }

     void setBorderlessButton(JButton button){
           button.setMargin(new Insets(0, 0, 0, 0));
           button.setBorderPainted(false);
           button.setContentAreaFilled(false);
           button.setFocusPainted(false);
       }

       public void setMoviePanel(boolean isMoviepanel){
       //movieJPanel.setVisible(isMoviepanel);
       }

       public void setButtonPanel(boolean isButtonpanel){
       //panel.setVisible(isButtonpanel);
       }

       public void mousePressed(MouseEvent e) {
           action = (JButton)e.getSource();
           int x = e.getX();
           boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
           mouseDownTime = System.currentTimeMillis();
                if (!doubleClick) {
                }
        }

        public void mouseReleased(MouseEvent e) {}
        public void mouseExited(MouseEvent e) {}
        public void mouseClicked(MouseEvent e) {}
        public void mouseEntered(MouseEvent e) {}

        public void mouseDragged(MouseEvent e) {}
        public void mouseMoved(MouseEvent e) {
            JButton action = (JButton)e.getSource();
            int x = e.getX();
            boolean doubleClick = (System.currentTimeMillis()-mouseDownTime)<=DOUBLE_CLICK_THRESHOLD;
            mouseDownTime = System.currentTimeMillis();
                 /*if (!false) {
                     if(action == infoButton){
                         IJ.showStatus("Command: Show Info...");
                     }
                     else if(action == brightnesContButton){
                         IJ.showStatus("Command: Brightnes/Contrast");
                     }
                     else if(action == winLevelButton){
                         IJ.showStatus("Command: Window/Level");
                     }
                     else if (action == draggedButton) {
                         IJ.showStatus("Move...");
                     }
                     else if (action == closeButton) {
                         IJ.showStatus("Decorated Frame");
                     }
                     else if (action == undecoratedButton) {
                         IJ.showStatus("Undecorated Frame");
                     }
                     else if(action == resizeCanButton){
                         IJ.showStatus("Command: Canvas Size...");
                     }
                     else if(action == thresholdButton){
                         IJ.showStatus("Command: Thresold...");
                     }

                 }*/
        }
        public void actionPerformed(ActionEvent e){
            /*try {
                if(action == infoButton){
                    IJ.doCommand("Show Info...");
                }
                else if(action == brightnesContButton){
                    IJ.runPlugIn("ij.plugin.frame.ContrastAdjuster", "");
                }
                else if(action == winLevelButton){
                    IJ.runPlugIn("ij.plugin.frame.ContrastAdjuster", "wl");
                }
                else if(action == colorBalButton){
                    IJ.runPlugIn("ij.plugin.frame.ContrastAdjuster", "balance");
                }
                else if(action == resizeCanButton){
                    IJ.runPlugIn("ij.plugin.CanvasResizer", "");
                }
                else if(action == thresholdButton){
                    IJ.runPlugIn("ij.plugin.frame.ThresholdAdjuster", "");
                }
            } catch (Exception ex) {

            }*/
        }
}
