package ij2x.plugin.frame;
import ij.*;
import ij.gui.*;
import ij.plugin.filter.PlugInFilterRunner;
import ij.plugin.frame.Recorder;
import ij.plugin.frame.PlugInFrame;
import ij.util.*;
import ij.plugin.PlugIn;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.AdjustmentListener;
import java.awt.event.FocusListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyListener;
import java.awt.event.WindowListener;
import java.awt.geom.RoundRectangle2D;
import java.util.Hashtable;
import java.util.Vector;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.event.*;
import javax.swing.border.Border;
import javax.swing.border.BevelBorder;

import com.bric.swing.ColorPickerSliderUI;
import com.bric.swing.ColorPicker;


public class RGBColor extends JPanel implements PlugIn, DocumentListener, ChangeListener, ActionListener {
    private static final long serialVersionUID = 1L;
    Color initialColor=new Color(255, 255, 0, 255);
    int red, green, blue, alpha;
    boolean useHSB;
    String title;
    boolean mono;
    private final int ssNumber = 4; 
    private Document[] colorsDoc=new Document[ssNumber];
    private JSlider[] slider=new JSlider[ssNumber] ;
    private JSpinner[] spinner=new JSpinner[ssNumber];
    private String[] rgbColor=new String[ssNumber];
    private int[] rgbcolor=new int[ssNumber];
    private BevelBorder bb ;//new BevelBorder for LOWER or RAISED type
    private Container container;
    private Hashtable labels;
    private boolean macro;
    
    public static final int MAX_SLIDERS = 25;
    protected Vector<JComponent> numberField, stringField, checkbox, choice, vslider, vspinner, spinnerField;
    protected JTextArea textArea1, textArea2;
    private Document[] numberDoc=new Document[ssNumber];
    protected JSlider manipSlider;
    protected Vector defaultValues,defaultText;
    protected JComponent theLabel;
    private int y=0;
    private GridBagLayout grid;
    private GridBagConstraints c;
    private boolean firstNumericField=true;
    private boolean firstSlider=true;
    public JPanel contentPane, rgbColorPane;
    private static int SPINNER_FIELD=2;
    private Border lightGrayBorder = BorderFactory.createBevelBorder(bb.LOWERED, Color.lightGray, Color.lightGray);
    /** The vertical slider */
    public JSlider sliderVertical = new JSlider(JSlider.VERTICAL,0,100,0);
    JPanel sliderPanel = new JPanel();
    ColorDemo cd;
    
    
    /** Constructs a RGBColor using the specified title and initial color. */
    public RGBColor(String title, Color initialColor, boolean useHSB) {
        this.title = title;
        this.initialColor = initialColor;
        grid = new GridBagLayout();

        c = new GridBagConstraints();
        rgbColorPane = new JPanel();
        contentPane = new JPanel();
        rgbColorPane.setLayout(grid);
        sliderPanel.setBorder(lightGrayBorder);
        contentPane.setBorder(lightGrayBorder);
        contentPane.setLayout(grid);
        
        Color c = initialColor;
        red = c.getRed();
        green=c.getGreen();
        blue = c.getBlue();
        mono = red==green && green==blue;
        this.useHSB = useHSB;
        
        run("");
    }
    public void run(String arg) {
    	cd = new ColorDemo(initialColor);
    	craeteVSlider();
    }
    public void craeteVSlider(){
        sliderVertical.addChangeListener(new ChangeListener(){
        	public void stateChanged(ChangeEvent e){
        		if(
        				true//ColorPane.instance.picker.getMode() == ColorPane.SAT || ColorPane.instance.picker.getMode() ==  ColorPane.BRI
        				){
        			slider[0].setValue(ColorPane.instance.picker.red.getIntValue());
        			  slider[1].setValue(ColorPane.instance.picker.green.getIntValue());
        			    slider[2].setValue(ColorPane.instance.picker.blue.getIntValue());
        			  slider[3].setValue(ColorPane.instance.picker.getColor().getAlpha());
        			//System.out.println(c);
        		}
        	}
        });

        sliderVertical.setUI(new ColorPickerSliderUI(sliderVertical, ColorPane.instance.picker));
          sliderVertical.setPaintTicks(true);
            sliderVertical.repaint();
    	  cd.setColor(ColorPane.instance.picker.getColor());
    	cd.repaint();
    
    }
    	   
    /** Displays a color selection dialog and returns the color selected by the user. */
    public JPanel createRGB() {
        //set slider values
        String redLabel=ColorPane.instance.picker.strings.getObject("redLabel").toString()
        		, greenLabel=ColorPane.instance.picker.strings.getObject("greenLabel").toString()
        		 , blueLabel=ColorPane.instance.picker.strings.getObject("blueLabel").toString()
        		  , alphaLabel=ColorPane.instance.picker.strings.getObject("alphaLabel").toString();
        int min=0, max=255;
        int redValue=Roi.getColor().getRed(), greenValue=Roi.getColor().getGreen(), blueValue=Roi.getColor().getBlue();
        int alphaValue=ColorPane.instance.picker.getColor().getAlpha();
        int mior=17;
        int major=255/3;
        int width=204, height=58;
        boolean paintticks=true, paintLabels=true;

        addJSlider(redLabel, min, max, redValue, major, mior, paintticks, paintLabels, width, height);
        addJSlider(greenLabel, min, max, greenValue, major, mior, paintticks, paintLabels, width, height);
        addJSlider(blueLabel, min, max, blueValue, major, mior, paintticks, paintLabels, width, height);
        addJSlider(alphaLabel, min, max, alphaValue, major, mior, paintticks, !paintLabels, width, height);

        for (int i=0; i<vslider.size(); i++){
            slider[i]=(JSlider) vslider.elementAt(i);
            slider[i].addChangeListener(this);
        }
        
        for (int i=0; i<vspinner.size(); i++){
            spinner[i]=(JSpinner) vspinner.elementAt(i);
            spinner[i].addChangeListener(this);
        }
        
        for (int i=0; i<spinnerField.size(); i++){
            colorsDoc[i] = ((JFormattedTextField) spinnerField.elementAt(i)).getDocument();
            colorsDoc[i].addDocumentListener(this);
            //System.out.println("i="+spinnerField.size());
        }
        
        sliderPanel.setLayout(new GridBagLayout());
    	//sliderPanel.add(sliderVertical, BorderLayout.CENTER);
    	
    	sliderPanel.add(sliderVertical, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    	sliderPanel.add(cd, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0
                ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    	
    	
        int swidth = sliderPanel.getPreferredSize().width;
        int sheight= contentPane.getPreferredSize().height;
        sliderPanel.setPreferredSize(new Dimension(swidth, sheight));
        
    	rgbColorPane.add(sliderPanel, new GridBagConstraints(0, 0, 1, 1, 0.3, 0.0
                ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    	rgbColorPane.add(contentPane, new GridBagConstraints(1, 0, 1, 1, 0.3, 0.0
                ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        return rgbColorPane;

    }
    void textValueChanged(DocumentEvent e){
    	Document doc = e.getDocument();
    	int parent = 256;
        try {
            for(int i=0; i < rgbColor.length; i++){
            	if(true){
                rgbColor[i] = colorsDoc[i].getText(0, colorsDoc[i].getLength());
                rgbcolor[i] = (int)Tools.parseDouble(rgbColor[i]);
                parent = i;
                
                if(rgbcolor[parent] < 0){rgbcolor[parent]=0;}
                else if(rgbcolor[parent] > 255){rgbcolor[parent]=255;}
                red=rgbcolor[0]; green=rgbcolor[1]; blue=rgbcolor[2];
                
                slider[i].removeChangeListener(this);
                slider[i].setValue(rgbcolor[i]);
                slider[i].addChangeListener(this);
                //System.out.println("color="+rgbcolor[i]);
            	}
            }
            initialColor=new Color(rgbcolor[0], rgbcolor[1], rgbcolor[2], rgbcolor[3]);
            ColorPane.instance.setSelectedColor(initialColor);
            ColorPane.instance.picker.setColor(initialColor);
            //System.out.println("color="+initialColor);
        } catch (Exception ex) {
         ex.printStackTrace();
        }
    }


    public synchronized void stateChanged(ChangeEvent e) {
            Object source = e.getSource();
            if(source instanceof JSlider){
            	sliderState_Changed(e);
            }else if(source instanceof JSpinner){
            	spinnerState_Changed(e);
            }
    }
    /**         */
    public void addJSlider(String label, double minValue, double maxValue, double defaultValue, double major, double minor, boolean paintTicks, boolean paintLabels, int width, int height) {
        addJSlider( label,  minValue,  maxValue,  defaultValue,  major,  minor,  paintTicks,  paintLabels,  width,  height,  1);
    }
    public void addJSlider(String label, double minValue, double maxValue, double defaultValue, double major, double minor, boolean paintTicks, boolean paintLabels, int width, int height, int stepSize) {
                 int columns = 4;
                 int digits = 0;
                 String label2 = label;
                 if (label2.indexOf('_')!=-1)
                         label2 = label2.replace('_', ' ');
                 JLabel theLabel = makeLabel(label2);
                 c.gridx = 0; c.gridy = y;
                 c.anchor = GridBagConstraints.EAST;
                 c.gridwidth = 1;
                 c.insets = new Insets(5, 5, 5, 5);
                 grid.setConstraints(theLabel, c);
                 theLabel.setBorder(lightGrayBorder);
                 contentPane.add(theLabel);
                 this.theLabel=theLabel;

                 if (vslider==null)
                         vslider = new Vector<JComponent>(5);
                 manipSlider = new JSlider();
                 JSlider s = createSlider(manipSlider, (int)minValue, (int)maxValue, (int)defaultValue, (int)major, (int)minor, paintTicks, paintLabels, width, height);
                 vslider.addElement(s);
                 s.addChangeListener(new ChangeListener(){
                     public void stateChanged(ChangeEvent e){
                     }
                 });
                 if (vspinner==null){
                         vspinner = new Vector<JComponent>(5);
                 }
                     SpinnerNumberModel snm = new SpinnerNumberModel((int)defaultValue, (int)minValue, (int)maxValue, 1);
                     JSpinner sp = new JSpinner(snm);

                     JSpinner.NumberEditor spde = new JSpinner.NumberEditor(sp);
                     spde.getFormat().setDecimalSeparatorAlwaysShown(true);
                     
                     JComponent editor = sp.getEditor();
                     
                     vspinner.addElement(sp);

                 if (spinnerField==null) {
                         spinnerField = new Vector<JComponent>(5);
                         defaultValues = new Vector<Comparable>(5);
                         defaultText = new Vector<Comparable>(5);
                 }
                 if (IJ.isWindows()) columns -= 1;
                 if (columns<1) columns = 1;
                 
                 sp.addChangeListener(new ChangeListener(){
                     public void stateChanged(ChangeEvent e){
                     }
                 });
                 JFormattedTextField tf = ((JSpinner.NumberEditor)editor).getTextField(); //new JTextField(IJ.d2s(defaultValue, digits), columns);
                 tf.addActionListener(this);
                 spinnerField.addElement(tf);
                 defaultValues.addElement(new Double(defaultValue));
                 defaultText.addElement(tf.getText());
                 tf.setEditable(true);
                 if (firstNumericField && firstSlider) tf.selectAll();
                 firstSlider = false;

                 JPanel panel = new JPanel();
                 panel.setBorder(lightGrayBorder);
                 GridBagLayout pgrid = new GridBagLayout();
                 GridBagConstraints pc  = new GridBagConstraints();
                 panel.setLayout(pgrid);
                 // slider
                 pc.gridx = 0; pc.gridy = 0;
                 pc.gridwidth = 1;
                 pc.ipadx = 0;//75;
                 pc.anchor = GridBagConstraints.WEST;
                 pgrid.setConstraints(s, pc);
                 panel.add(s);
                 pc.ipadx = 0;  // reset
                 // text field
                 pc.gridx = 1;
                 pc.insets = new Insets(5, 5, 5, 5);
                 pc.anchor = GridBagConstraints.EAST;
                 pgrid.setConstraints(sp, pc);
                 
                 panel.add(sp);

                 c.gridx = 1; c.gridy = y;
                 c.gridwidth = 1;
                 c.anchor = GridBagConstraints.WEST;
                 c.insets = new Insets(2, 0, 2, 0);
                 grid.setConstraints(panel, c);
                 contentPane.add(panel);
                 y++;
                 if (Recorder.record || macro)
                         saveLabel(tf, label);
     }
     /** create and initialize JSlider */
     public JSlider createSlider(JSlider manipSlider
    		 , int min
    		  , int max
    		   , int start
    		    , int major
    		     , int minor
    		      , boolean paintTicks
    		       , boolean paintLabels
    		        , int width
    		         , int height){
        this.manipSlider=manipSlider;
                      manipSlider.setMinimum(min);
                     manipSlider.setMaximum(max);
                   manipSlider.setValue(start);
                 manipSlider.setMajorTickSpacing(major);
               manipSlider.setMinorTickSpacing(minor);

        manipSlider.setPaintTicks(paintTicks);
         manipSlider.setPaintLabels(paintLabels);
        manipSlider.setPreferredSize(new Dimension(width, height));

        return manipSlider;
     }
     public void insertUpdate(DocumentEvent e){
    	 textValueChanged(e);
     }
     public void removeUpdate(DocumentEvent e){
    	 textValueChanged(e);
    }
     public void changedUpdate(DocumentEvent e){
     }

     public void actionPerformed(ActionEvent e) {
         Object source = e.getSource();
     }

     void sliderState_Changed(ChangeEvent e) {
         Object source = e.getSource();
         for (int i=0; i<vslider.size(); i++) {
                 if (source==vslider.elementAt(i)) {
                         JSlider sl = (JSlider) source;
                           spinner[i] = (JSpinner)vspinner.elementAt(i);
                          spinner[i].setValue(new Integer(sl.getValue()));
                         sliderVertical.repaint();
                         //sliderVertical.setValue(((JSlider)vslider.elementAt(i)).getValue());
                 }
                 cd.setColor(new Color(slider[0].getValue(), slider[1].getValue(), slider[2].getValue(), slider[3].getValue()));
                 cd.repaint();
         }
     }

     void spinnerState_Changed(ChangeEvent e) {
         Object source = e.getSource();
         for (int i=0; i<vspinner.size(); i++) {
                 if (source==vspinner.elementAt(i)) {
                         JSpinner sp = (JSpinner)source;
                          JSlider sl = (JSlider) vslider.elementAt(i);
                         sl.setValue(((Number)sp.getValue()).intValue());
                     
                 }
         }
     }
     private JLabel makeLabel(String label) {
     if (IJ.isMacintosh())
             label += " ";
             return new JLabel(label);
     }

     private void saveLabel(JComponent component, String label) {
         if (labels==null)
                 labels = new Hashtable();
         if (label.length()>0) {
                 if (label.charAt(0)==' ')
                         label = label.trim();
                         labels.put(component, label);
                 }
     }
     public void setColor(Color c){
    	 this.initialColor=c;
    	   red=c.getRed();
    	     slider[0].setValue(red);
    	       green=c.getGreen();
    	       slider[1].setValue(green);
    	     blue=c.getBlue();
    	   slider[2].setValue(blue);
    	   alpha=c.getAlpha();
    	   slider[3].setValue(alpha);
     }
     public Color getColor(){
    	 return this.initialColor=new Color(red, green, blue, alpha);
     }


     public static void main(String args[]) {
	         //new RGBColor("RGB Color", Color.green, true).run("");
     }
 	public void updateSlider(JSlider slider) {
 		com.bric.swing.ColorPicker picker = ColorPane.instance.picker;
		try {
			int mode = picker.getMode();
			if(mode==ColorPane.HUE) {
				slider.setValue( picker.hue.getIntValue() );
                                slider.setMajorTickSpacing(90);
                                slider.setMinorTickSpacing(9);
			} else if(mode==ColorPane.SAT) {
				slider.setValue( picker.sat.getIntValue() );
                                slider.setMajorTickSpacing(25);
                                slider.setMinorTickSpacing(5);
			} else if(mode==ColorPane.BRI) {
				slider.setValue( picker.bri.getIntValue() );
                                slider.setMajorTickSpacing(25);
                                slider.setMinorTickSpacing(5);
			} else if(mode==ColorPane.RED) {
				slider.setValue( picker.red.getIntValue() );
                                slider.setMajorTickSpacing(64);
                                slider.setMinorTickSpacing(16);
			} else if(mode==ColorPane.GREEN) {
				slider.setValue( picker.green.getIntValue() );
                                slider.setMajorTickSpacing(64);
                                slider.setMinorTickSpacing(16);
			} else if(mode==ColorPane.BLUE) {
				slider.setValue( picker.blue.getIntValue() );
                                slider.setMajorTickSpacing(64);
                                slider.setMinorTickSpacing(16);
			}
		} finally {
		}
		slider.repaint();
	}
   }
class ColorDemo extends JPanel {
    BasicStroke stroke;
    Color c;
    static final int length = 40;
    static final int WIDTH=length, HEIGHT=60;
    Font font;
    ColorDemo(Color c) {
        this.c = c;
    }

    public Dimension getPreferredSize() {
        return new Dimension(WIDTH, HEIGHT);
    }

    void setColor(Color c) {
        this.c = c;
    }

    public Dimension getMinimumSize() {
        return new Dimension(WIDTH, HEIGHT);
    }
    public void update(Graphics g) {
       paintComponent(g);
    }

    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D g2D = (Graphics2D)g;
        RoundRectangle2D roundRect;
        double x0 = 15.0;
        double sw = 10.0;
        double sh =35.0;
        double y0 = 5.0;
        float width = 2f;
        boolean raised=true;

        g2D.setColor(c);
        g2D.setStroke(new BasicStroke(width, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL));
        g2D.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        g2D.setColor(Color.GRAY);
        g2D.draw3DRect((int)x0, (int)y0, (int)sw+1, (int)sh, raised);
        roundRect = new RoundRectangle2D.Double(x0+1, y0+1, sw, sh-1, 0, 0);
        Shape shape = roundRect;
        //g2D.draw(shape);
        g2D.setColor(c);
        g2D.fill(roundRect);
    }


}


